#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "codeeditor.h"


void MainWindow::ParseGcode()
{
    QStringList GLines = ui->plainTextEditGCode->toPlainText().split(QRegExp("[\r\n]"),QString::SkipEmptyParts);
    if(GLines.isEmpty()){return;}

    PreviewData.clear();

    QStringList RegExpList;
    QList<float*>DataPtrsFloat;
    QList<int*>DataPtrsInt;

    RegExpList<<"[xX]-?[0-9]*\\.?[0-9]*";
    RegExpList<<"[yY]-?[0-9]*\\.?[0-9]*";
    RegExpList<<"[zZ]-?[0-9]*\\.?[0-9]*";
    RegExpList<<"[iI]-?[0-9]*\\.?[0-9]*";
    RegExpList<<"[jJ]-?[0-9]*\\.?[0-9]*";
    RegExpList<<"[gG][0-9]*";
    RegExpList<<"[mM][0-9]*";

    float X = 0;
    float Y = 0;
    float Z = 0;
    float I = 0;
    float J = 0;
    int G = 0;
    int M = 0;

    PreviewData.append(QVector4D(X,Y,Z,(float)G)); //ToDo: Hier Maschinenkoordinaten

    DataPtrsFloat<<&X<<&Y<<&Z<<&I<<&J;
    DataPtrsInt<<&G<<&M;

    bool IncMode = false;

    for(int i = 0; i < GLines.size(); i++){

        QString Line = GLines.at(i);
        G = -1;

        for(int k = 0; k < RegExpList.size(); k++){
            QRegExp Expression =  QRegExp(RegExpList.value(k,""));

            int index = Line.indexOf(Expression);
            if(index >= 0){
                int length = Expression.matchedLength();
                if(k < 5){
                    *(DataPtrsFloat.at(k)) = Line.mid(index+1,length-1).toFloat();
                }else{
                    *(DataPtrsInt.at(k-5)) = Line.mid(index+1,length-1).toInt();
                }
            }
        }

        QPointF Start,Center,End;
        QLineF L1,L2;
        qreal A1, A2, AInc, D, StartZ, ZInc;

        switch(G){
            case 0: case 1:
                PreviewData.append(QVector4D(X,Y,Z,(float)G)); break;

            case 2: case 3:
                if(PreviewData.isEmpty()){
                    Start = QPointF(0,0);
                    StartZ = 0;
                }else{
                    Start = QPointF(PreviewData.last().toPointF());
                    StartZ = PreviewData.last().z();
                }
                Center = QPointF(Start.x()+I, Start.y()+J);
                End = QPointF(X,Y);

                L1 = QLineF(Center, Start);
                L2 = QLineF(Center, End);


                A1 = 360.0-L1.angle();//Spiegeln ntig das Koordinatensysteme gespiegelt ist
                A2 = 360.0-L2.angle();
                D = L1.length();

                AInc = qMin(360/D,10.0);
                if(G == 2){
                    AInc = -AInc;
                    if(A1<=A2){A1 += 360.0;}
                }else{
                    if(A1>=A2){A2 += 360.0;}
                }
                ZInc = (Z-StartZ)/(qAbs(A1-A2)/qAbs(AInc));

                while(1){
                    A1+=AInc;
                    StartZ+=ZInc;
                    if(G == 2){
                        if(A1<=A2){break;}
                    }else{
                        if(A1>=A2){break;}
                    }
                    PreviewData.append(QVector4D(Center.x() + D*qCos(qDegreesToRadians(A1)), Center.y() + D*qSin(qDegreesToRadians(A1)),StartZ,(float)G));
                }
                PreviewData.append(QVector4D(X,Y,Z,(float)G)); break;
            default:
            break;

        }
    }

}
