#include "GCodeSyntaxHighlighter.h"
#include <QString>

GCodeSyntaxHighlighter::GCodeSyntaxHighlighter(QTextDocument *document) :
    QSyntaxHighlighter(document)
{
}

void GCodeSyntaxHighlighter::highlightBlock(const QString &text)
{
    QTextCharFormat ClassFormat;
    QRegExp Expression;

    ClassFormat.setFontWeight(QFont::Bold);

    QStringList RegExpList;
    QList<QColor> ColorList;

    RegExpList<<"[nN][0-9]*";
    ColorList<<Qt::gray;

    RegExpList<<"[mM][0-9]*";
    ColorList<<Qt::red;

    RegExpList<<"[gG][0-9]*";
    ColorList<<Qt::darkBlue;

    RegExpList<<"[xX]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkGreen;

    RegExpList<<"[yY]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkCyan;

    RegExpList<<"[zZ]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::blue;

    RegExpList<<"[iI]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkYellow;

    RegExpList<<"[jJ]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkYellow;

    RegExpList<<"[kK]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkYellow;

    RegExpList<<"[rR]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkGray;

    RegExpList<<"[sS]-?[0-9]*\\.?[0-9]*";
    ColorList<<Qt::darkMagenta;

    RegExpList<<"[fF]-?[0-9]*\\.?[0-9]*";
    ColorList<<QColor(255,127,35);

    RegExpList<<"[(][^)]*[)]";
    ColorList<<Qt::black;


    for(int k = 0; k < RegExpList.size(); k++){
        ClassFormat.setForeground(ColorList.value(k,Qt::red));
        Expression =  QRegExp(RegExpList.value(k,""));
        int index = text.indexOf(Expression);
        while (index >= 0) {
            int length = Expression.matchedLength();
            setFormat(index, length, ClassFormat);
            index = text.indexOf(Expression, index + length);
        }
    }
}
