#ifndef GRBLSETTINGSDIALOG_H
#define GRBLSETTINGSDIALOG_H

#include <QDialog>
#include <QString>
#include <QList>

struct GrblParameter{
    unsigned char Index;
    double  Value;
    QString Description;
    GrblParameter( unsigned char i, double v, QString d):Index(i),Value(v),Description(d){};
};

namespace Ui {
class GrblSettingsDialog;
}

class GrblSettingsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit GrblSettingsDialog(QWidget *parent = 0);
    ~GrblSettingsDialog();
    void ParseParameterString(QString ParamStr);

private slots:
    void on_pushButtonClose_clicked();
    void on_pushButtonApply_clicked();
    void cellChanged(int row, int column);

private:

    QList<GrblParameter> ParametersList;
    int GetListIndexOfParameterWithIdx(int Idx);
    void refreshList();
    void AddParameterToList(GrblParameter NewParameter);
    Ui::GrblSettingsDialog *ui;
};

#endif // GRBLSETTINGSDIALOG_H
