// openglwidget.h

#ifndef OPENGLWIDGET_H
#define OPENGLWIDGET_H

#include <QGLWidget>
#include <QVector4D>
#include <qlcdnumber.h>

class OpenGLWidget : public QGLWidget
{
    Q_OBJECT
public:
    explicit OpenGLWidget(QWidget *parent = 0);
    ~OpenGLWidget();

    QVector<QVector4D> * PreviewDataPtr;

    void setOriginDrawing(bool draw);
    void setBoundingDrawing(bool draw);
    void setViewFromAbove();

    QLCDNumber * NumberLCDsPtrs[3];



signals:

public slots:

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);

    QSize minimumSizeHint() const;
    QSize sizeHint() const;
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void wheelEvent(QWheelEvent *event);

signals:
    // signaling rotation from mouse movement
    void xRotationChanged(int angle);
    void yRotationChanged(int angle);
    void zRotationChanged(int angle);

private:
    void drawOrigin();
    void draw();
    bool DoDrawOrigin;
    bool DoDrawBounding;

    int xRot;
    int yRot;
    int zRot;
    int xMove;
    int yMove;
    int zMove;
    int Zoom;

    float WindowRatio;
    float min_x = 0;
    float max_x = 0;
    float min_y = 0;
    float max_y = 0;
    float min_z = 0;
    float max_z = 0;

    QPoint lastPos;
};

#endif // OPENGLWIDGET_H

