#include "preview3d.h"
#include "ui_preview3d.h"

Preview3D::Preview3D(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Preview3D)
{
    setWindowFlags(windowFlags() | Qt::WindowMaximizeButtonHint);
    ui->setupUi(this);

    ui->GLWidget->NumberLCDsPtrs[0] = ui->lcdNumberX;
    ui->GLWidget->NumberLCDsPtrs[1] = ui->lcdNumberY;
    ui->GLWidget->NumberLCDsPtrs[2] = ui->lcdNumberZ;
}

Preview3D::~Preview3D()
{
    delete ui;
}

void Preview3D::SetDataPointer(QVector<QVector4D> *PreviewDataPtr)
{
    ui->GLWidget->PreviewDataPtr = PreviewDataPtr;
}

void Preview3D::Update()
{
    ui->GLWidget->updateGL();
}

void Preview3D::on_checkBoxOrigin_clicked(bool checked)
{
    ui->GLWidget->setOriginDrawing(checked);
}

void Preview3D::on_checkBoxBounding_clicked(bool checked)
{
    ui->GLWidget->setBoundingDrawing(checked);
}

void Preview3D::on_pushButtonLookFromAbove_clicked()
{
    ui->GLWidget->setViewFromAbove();
}
