#include "probingdialog.h"
#include "ui_probingdialog.h"
#include "mainwindow.h"
#include <QDebug>



ProbingDialog::ProbingDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ProbingDialog)
{
    Mode = DONE;
    ui->setupUi(this);
}

ProbingDialog::~ProbingDialog()
{
    delete ui;
}

void ProbingDialog::setGRBLStatusString(QString StatStr)
{
    GRBLStatus = StatStr;
    if(GRBLStatus == "Idle"){

        if(Mode == RUNING){
           Mode = DONE;

           MainWindow * TheMainWindow = 0;
           if(parent()){
             TheMainWindow = static_cast<MainWindow*>(parent());
           }else{
               return;
           }

           if(ui->checkBoxAutoSetPos->isChecked()){
                QString CommandStr = "G92 ";
               CommandStr += getAxisChar();
               CommandStr += QString::number(ui->heightSpinBox->value());
               TheMainWindow->TryToSendLineAndAddToConsoleText(CommandStr);
           }
        }

    }else{
        if(Mode == STARTED){Mode = RUNING;}
    }


    ui->pushButtonProbe->setEnabled((GRBLStatus == "Idle"));
}

void ProbingDialog::on_checkBoxAutoSetPos_toggled(bool checked)
{
    ui->heightSpinBox->setEnabled(checked);
}

void ProbingDialog::on_pushButtonProbe_clicked()
{
    MainWindow * TheMainWindow = 0;
    if(parent()){
      TheMainWindow = static_cast<MainWindow*>(parent());
    }else{
        return;
    }

    QString CommandStr = "G38.2 ";

    CommandStr += getAxisChar();
    if(ui->distanceSpinBox->value() >= 0){CommandStr += '+';}

    CommandStr+= QString::number(ui->distanceSpinBox->value());
    CommandStr+=" F";
    CommandStr+= QString::number(ui->speedSpinBox->value());

    if(TheMainWindow){
        TheMainWindow->TryToSendLineAndAddToConsoleText("G91");
        TheMainWindow->TryToSendLineAndAddToConsoleText(CommandStr);
        Mode = STARTED;
    }
}

QChar ProbingDialog::getAxisChar()
{
    if(ui->radioButtonX->isChecked()){return 'X';}
    if(ui->radioButtonY->isChecked()){return 'Y';}
    if(ui->radioButtonZ->isChecked()){return 'Z';}
    return ' ';
}
