#ifndef WINDOWSGAMEPAD_H
#define WINDOWSGAMEPAD_H

#include <QObject>
#include <QTimer>
//#include <QtGamepad>


#if defined(Q_OS_WIN)
    #include <Windows.h>
#endif

enum GamepadButton{X_PLUS = 0, X_MINUS = 1, Y_PLUS = 2, Y_MINUS = 3, Z_PLUS = 4, Z_MINUS = 5, ZERO = 6, SLOW = 7, MEDIUM_SPEED = 8, START = 9, SPINDLE = 10, DEFINED_STEP = 11};
const int BUTTON_COUNT = 12;

struct GamepadState{
    bool Buttons[BUTTON_COUNT];
};

class WindowsGamepad : public QObject
{
    Q_OBJECT
public:
    explicit WindowsGamepad(QObject *parent = 0);

    bool ButtonState(GamepadButton Button);

signals:
    void ButtonPressed(GamepadButton Button);
    void ButtonReleased(GamepadButton Button);

public slots:
    void UpdateTickSlot();
private:
    void FindGamepad();
    QTimer UpdateTickTimer;
    #if defined(Q_OS_WIN)
        JOYINFOEX info;
    #endif

    GamepadState LastState;

    int GamePadId;

//    QGamepad GP;

};

inline bool WindowsGamepad::ButtonState(GamepadButton Button){ return LastState.Buttons[Button];}


#endif // WINDOWSGAMEPAD_H
